      subroutine generate_he_em(x,pfer,which_pion)
      implicit none
      
      include 'target.inc'
      include 'constants.inc'
 
      real*4 x, hrndm1
      real*4 em_func,xmin,xmax,deutprob,tmpran
      real*8 pfer
      real*8 grnd
      external em_func, hrndm1
      logical first,which_pion


      data first /.TRUE./

      if(first) then 
         xmin = 2.*mp + mn - targ.M
         xmax = 100.0
         call hbfun1(2000,'he_em',200,xmin,xmax,em_func) 
         write(6,*) 'SUCCESS, Helium EM histo created'
         first = .FALSE.
      endif

      x = hrndm1(2000)
      if(which_pion.eq.0 .or. which_pion.eq.10) then
        deutprob = 0.77973 - 0.001605*pfer
        if(deutprob.le.0.) deutprob = 0.0
        tmpran = grnd()
        if(tmpran.lt.deutprob) then
          x = mp + md - targ.M
        endif
      endif

      return
      end

      real*4 function em_func(x)
      
      real*4 x
      em_func = 21296.0/(x**4.6217)

      return
      end

